<?php
//session handling information please!
session_start();
header("Cache-control: private"); //IE 6 fix

include("../misc/agenda.php");
include("../misc/aux.php");
include("../primitives/atom.php");
include("../primitives/fact.php");
include("../primitives/variable.php");
include("../primitives/rule.php");
include("../primitives/match.php");
include("../knowledgeBase.php");
include("../parser.php");
include("../jtms/jtms.php");
include("../jtms/jtmsNode.php");

//enter rules here
$Rules = "eng(*A*, yes) => recommendation(english);";
$Rules .= "org(*A*, yes) => recommendation(organisation);";
$Rules .= "read(*A*, yes) => recommendation(readability);";
$Rules .= "organised(*A*) => recommendation(presentation, *A*);";
$Rules .= "english(*A*) => recommendation(presentation, *A*);";
$Rules .= "readability(*A*) => recommendation(presentation, *A*);";
$Rules .= "bibliography(*A*) => recommendation(presentation, *A*);";
$Rules .= "recommendation(bibliography, *A*) => recommendation(presentation, *A*);";
$Rules .= "recommendation(readability, *A*) => recommendation(presentation, *A*);";
$Rules .= "recommendation(english, *A*) => recommendation(presentation, *A*);";
$Rules .= "recommendation(organisation, *A*) => recommendation(presentation, *A*);";
$Rules .= "previouslyPublished(no) ^ simlarWork(good) => recommendation(originality, excellent);";
$Rules .= "previouslyPublished(no) ^ simlarWork(poor) ^ simlarWork(isolated) => recommendation(originality, average);";


?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
<TITLE>ERA2: Gathering initial info</TITLE>
<META NAME="Generator" CONTENT="EditPlus">
<META NAME="Author" CONTENT="D Crighton">
<META NAME="Keywords" CONTENT="">
<META NAME="Description" CONTENT="">
<link rel="stylesheet" href="style.css" type="text/css"> 

<SCRIPT LANGUAGE="JavaScript">

function popUp(URL) {
eval("page" + id + " = window.open(URL, '" + id + "', 'toolbar=0,scrollbars=1,location=0,statusbar=1,menubar=0,resizable=1,width=800,height=600,left = 240,top = 212');");
}

</script>


</HEAD>

<BODY>
<div id = "header">
<img src = "./images/logo.gif"/>
</div>

<div id="wrapper">

	<div id = "container">
		<div id = "content">
			<br><br>Initialising Knowledgebase
			<? 
			$kb = new knowledgeBase();
			?>
			<br>Loading Initial Conditions into Knowledgebase
			<?
			$kb = parse($Rules, $kb);
			?>
			<br>Creating JTMS
			<?
			$jtms = new jtms($kb);
			?>
			<br>Registering JTMS
			<?
			$kb->register_jtms($jtms);
			?>
			Creating initial agenda
			<?
			$agenda = new agenda();
			$agenda->queue[] = "getInfo.php";
			$agenda->queue[] = "summary.php";
			$agenda->queue[] = "relevance.php";
			$agenda->queue[] = "originality.php";
			$agenda->queue[] = "validity.php";
			$agenda->queue[] = "presentation.php";
			
			$_SESSION["seen"]["getInfo.php"] = "false";
			$_SESSION["seen"]["technique.php"] = "false";
			$_SESSION["seen"]["summary.php"] = "false";
			$_SESSION["seen"]["relevance.php"] = "false";
			$_SESSION["seen"]["originality.php"] = "false";
			$_SESSION["seen"]["validity.php"] = "false";
			$_SESSION["seen"]["presentation.php"] = "false";
			?>
			<br>Registering session variables
			<?
			$_SESSION["kb"] = $kb;
			$_SESSION["jtms"] = $jtms;
			$_SESSION["agenda"] = $agenda;
			?>
			<br>Starting ....
			<?
			$url = $_SESSION["agenda"]->peek();
			echo("<script>window.location=\"$url\";</script>");
			?>
			
			
			<br><br><br>
	</div>
</div>

	<div id = "sidebar">
		Menu
		<br><br><a href = "destroy.php">Destroy Session</a>
	</div>
	<div class="clearing">&nbsp;</div>
	</div>
</div>

	<div id = "footer">
	<a href = "mailto:crighton@gmail.com">Dave Crighton</a>: MSc Student<br>
	<a href = "http://www.inf.ed.ac.uk">School of Informatics</a><br>
	University of Edinburgh<br>
	</div>


</BODY>
</HTML>
