<?php
//session handling information please!
include("../misc/agenda.php");
include("../misc/aux.php");
include("../primitives/atom.php");
include("../primitives/fact.php");
include("../primitives/variable.php");
include("../primitives/rule.php");
include("../primitives/match.php");
include("../knowledgeBase.php");
include("../parser.php");
include("../jtms/jtms.php");
include("../jtms/jtmsNode.php");

session_start();
header("Cache-control: private"); //IE 6 fix

$_SESSION["seen"]["summary.php"] = "true";

$_SESSION["agenda"]->pop();
clearSessionVariables();
handleTechnique();
handleProblem();
handleSurvey();
handleHypothesis();
handleSystem();
$_SESSION["history"][] = "summary.php";
//print_r($_SESSION["agenda"]);
$url = $_SESSION["agenda"]->peek();
echo("<meta http-equiv=\"refresh\" content=\"0;url=$url\">");


function handleTechnique(){
		if(isset($_POST["techniqueRadio"])){
			$value = $_POST["techniqueRadio"];
			$_SESSION["Techniques"] = $value;
			if($_SESSION["Techniques"] == "yes"){
				$fact = new fact("describesTechnique", Array(new atom("paper")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["summaryHandler.php"][] = $fact;	
			}
		}
		if(isset($_POST["techniqueQuantity"])){
			$value = $_POST["techniqueQuantity"];
			$_SESSION["TechniqueQuantity"] = $value;	
			for($i = 1; $i < $value + 1; $i++){
				$stringIdentifier = "techniqueName" . $i;
				if(isset($_POST[$stringIdentifier])){
					$_SESSION["TechniqueNames"][$i] = $_POST[$stringIdentifier];
				}
			}
			for($i = $value; $i > 0; $i--){
				//handle changes to program flow
				$pageId = "technique.php?TechniqueNumber=" . $i;
				if(!in_o_Array($pageId, $_SESSION["history"]) && !in_o_Array($pageId, $_SESSION["agenda"]->queue)){
					$_SESSION["agenda"]->enqueue($pageId);	
				}	
			}
		}
		
}

function handleProblem(){
	if(isset($_POST["problemRadio"])){
		$value = $_POST["problemRadio"];
		$_SESSION["Problem"] = $value;
		if($_SESSION["Problem"] == "yes"){
				$fact = new fact("describesProblem", Array(new atom("paper")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["summaryHandler.php"][] = $fact;	
			}
		if(isset($_POST["newProblemDescription"])){
			$_SESSION["NewProblemDescription"] = $_POST["newProblemDescription"];	
		}
		if(isset($_POST["problemSignificant"])){
			if($_POST["problemSignificant"] == "Very significant" ){
				$_SESSION["ProblemSignificant"] = 1;
				$fact = new fact("newProblem", Array(new atom("significant")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["summaryHandler.php"][] = $fact;
		}
		elseif($_POST["problemSignificant"] == "Somewhat significant"){
				$_SESSION["ProblemSignificant"] = 2;
		}
		elseif($_POST["problemSignificant"] == "Not significant"){
				$_SESSION["ProblemSignificant"] = 3;
		}
		else{
				$_SESSION["ProblemSignificant"] = 0;
			}
		}
	}
}

function handleSurvey(){
	if(isset($_POST["surveyRadio"])){
		$value = $_POST["surveyRadio"];
		$_SESSION["Survey"] = $_POST["surveyRadio"];
		if($_SESSION["Survey"] == "yes"){
				$fact = new fact("describesSurvey", Array(new atom("paper")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["summaryHandler.php"][] = $fact;	
		}
		if(isset($_POST["surveyDescription"])){
			$_SESSION["SurveyDescription"] = $_POST["surveyDescription"];	
		}
		if(isset($_POST["surveyDeep"])){
			$_SESSION["SurveyDepth"] = $_POST["surveyDeep"];	
			if($_SESSION["SurveyDepth"] == 1){
				$fact = new fact("surveyDepth", Array(new atom("good")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["summaryHandler.php"][] = $fact;	
			}
			elseif($_SESSION["SurveyDepth"] == 2){
				$fact = new fact("surveyDepth", Array(new atom("average")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["summaryHandler.php"][] = $fact;	
			}
			elseif($_SESSION["SurveyDepth"] == 3){
				$fact = new fact("surveyDepth", Array(new atom("poor")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["summaryHandler.php"][] = $fact;	
			}
		} 	
		if(isset($_POST["surveyBroad"])){
			$_SESSION["SurveyBreadth"] = $_POST["surveyBroad"];	
			if($_SESSION["SurveyBreadth"] == 1){
				$fact = new fact("SurveyBreadth", Array(new atom("good")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["summaryHandler.php"][] = $fact;	
			}
			elseif($_SESSION["SurveyBreadth"] == 2){
				$fact = new fact("SurveyBreadth", Array(new atom("average")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["summaryHandler.php"][] = $fact;	
			}
			elseif($_SESSION["SurveyBreadth"] == 3){
				$fact = new fact("SurveyBreadth", Array(new atom("poor")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["summaryHandler.php"][] = $fact;	
			}
		} 
		if(isset($_POST["surveyCurrent"])){
			$_SESSION["SurveyCurrent"] = $_POST["surveyCurrent"];
			if($_SESSION["surveyCurrent"] == 1){
				$fact = new fact("surveyCurrent", Array(new atom("good")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["summaryHandler.php"][] = $fact;	
			}
			elseif($_SESSION["surveyCurrent"] == 2){
				$fact = new fact("surveyCurrent", Array(new atom("average")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["summaryHandler.php"][] = $fact;	
			}
			elseif($_SESSION["surveyCurrent"] == 3){
				$fact = new fact("surveyCurrent", Array(new atom("poor")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["summaryHandler.php"][] = $fact;
			}
				
		}
		if(isset($_POST["surveyOmmisionsRadio"])){
			$_SESSION["SurveyOmmisions"] = $_POST["surveyOmmisionsRadio"];	
			if($_SESSION["surveyOmmisions"] == "yes"){
				$fact = new fact("surveyOmmisions", Array(new atom("true")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["summaryHandler.php"][] = $fact;
			}
		}
		if(isset($_POST["surveyOmitDescription"])){
			$_SESSION["SurveyOmitDescription"] = $_POST["surveyOmitDescription"];	
		}
	}	
}

function handleHypothesis(){
	if(isset($_POST["hypothesesQuantity"])){
		$value = $_POST["hypothesesQuantity"];
		$_SESSION["HypothesisQuantity"] = $_POST["hypothesesQuantity"];	
	}
	for($i = 1; $i < $value + 1; $i++){
		$stringIdentifier = "hypName" . $i;
		if(isset($_POST[$stringIdentifier])){
			$_SESSION["HypothesisNames"][$i] = $_POST[$stringIdentifier];	
		}
		$stringIdentifier = "hypDescription" . $i;
		if(isset($_POST[$stringIdentifier])){
			$_SESSION["HypothesisDescriptions"][$i] = $_POST[$stringIdentifier];	
		}
		$stringIdentifier = "hypEvidenceDescription" . $i;
		if(isset($_POST[$stringIdentifier])){
			$_SESSION["HypothesisEvidenceDescriptions"][$i] = $_POST[$stringIdentifier];	
		}
		$stringIdentifier = "hypEvidenceType" . $i;
		if(isset($_POST[$stringIdentifier])){
			$_SESSION["HypothesisEvidenceTypes"][$i] = $_POST[$stringIdentifier];	
			if($_SESSION["HypothesisEvidenceTypes"][$i] == 1){
				$fact = new fact("evidenceType", Array(new atom("theoretical")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["summaryHandler.php"][] = $fact;	
			}
			elseif($_SESSION["HypothesisEvidenceTypes"][$i] == 2){
				$fact = new fact("evidenceType", Array(new atom("experimental")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["summaryHandler.php"][] = $fact;	
			}
			elseif($_SESSION["HypothesisEvidenceTypes"][$i] == 3){
				$fact = new fact("evidenceType", Array(new atom("experimental")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["summaryHandler.php"][] = $fact;
				$fact = new fact("evidenceType", Array(new atom("theoretical")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["summaryHandler.php"][] = $fact;	
			}
		}
		$stringIdentifier = "hypFormation" . $i;
		if(isset($_POST[$stringIdentifier])){
			$_SESSION["HypothesisFormations"][$i] = $_POST[$stringIdentifier];
			if($_SESSION["HypothesisFormations"][$i] == 1){
				$fact = new fact("hypType", Array(new atom("confirmatory")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["summaryHandler.php"][] = $fact;	
			}
			elseif($_SESSION["HypothesisFormations"][$i] == 2){
				$fact = new fact("hypType", Array(new atom("exploratory")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["summaryHandler.php"][] = $fact;	
			}	
		}
	}
}

function handleSystem(){
	if(isset($_POST["systemRadio"])){
		$_SESSION["System"] = $_POST["systemRadio"];	
		if($_SESSION["System"] == "yes"){
			$fact = new fact("describesSystem", Array(new atom("paper")));
			$_SESSION["kb"]->add_fact($fact);
			$_SESSION["facts"]["summaryHandler.php"][] = $fact;	
		}
	}
	if(isset($_POST["systemName"])){
		$_SESSION["SystemName"] = $_POST["systemName"];	
	}
	if(isset($_POST["systemType"])){
		$_SESSION["SystemType"] = $_POST["systemType"];	
		if($_SESSION["SystemType"] == 1){
			$fact = new fact("systemType", Array(new atom("new")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["summaryHandler.php"][] = $fact;		
		}
		if($_SESSION["SystemType"] == 2){
			$fact = new fact("systemType", Array(new atom("combination")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["summaryHandler.php"][] = $fact;		
		}
		if($_SESSION["SystemType"] == 3){
			$fact = new fact("systemType", Array(new atom("update")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["summaryHandler.php"][] = $fact;		
		}
	}
	if(isset($_POST["systemDescription"])){
		$_SESSION["SystemDescription"] = $_POST["systemDescription"];	
	}
	if(isset($_POST["newSystemDescription"])){
		$_SESSION["SystemAdvantages"] = $_POST["newSystemDescription"];	
	}
	
	if(isset($_POST["previousSystemDifferences"])){
		$_SESSION["PreviousSystemDifferences"] = $_POST["previousSystemDifferences"];	
	}
	if(isset($_POST["previousSystemAuthor"])){
		$_SESSION["PreviousSystemAuthor"] = $_POST["previousSystemAuthor"];	
	}
	if(isset($_POST["previousSystemName"])){
		$_SESSION["PreviousSystemName"] = $_POST["previousSystemName"];	
	}
	if(isset($_POST["systemDiffers"])){
		$_SESSION["SystemDiffers"] = $_POST["systemDiffers"];	
	}
	if(isset($_POST["toolsQuantity"])){
		$_SESSION["ToolsQuantity"] = $_POST["toolsQuantity"];
		$value = $_POST["toolsQuantity"];	
	}
	for($i = 1; $i < $value + 1; $i++){
		$stringIdentifier = "toolName" . $i;
		if(isset($_POST[$stringIdentifier])){
			$_SESSION["ToolNames"][$i] = $_POST[$stringIdentifier];	
		}
		$stringIdentifier = "toolDescription" . $i;
		if(isset($_POST[$stringIdentifier])){
			$_SESSION["ToolDescriptions"][$i] = $_POST[$stringIdentifier];	
		}	
		$stringIdentifier = "toolSuited" . $i;
		if(isset($_POST[$stringIdentifier])){
			$_SESSION["ToolSuited"][$i] = $_POST[$stringIdentifier];	
			if($_SESSION["ToolSuited"] == 1){
				$fact = new fact("toolSuited", Array(new atom($i), new atom("good")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["summaryHandler.php"][] = $fact;		
			}	
			elseif($_SESSION["ToolSuited"] == 2){
				$fact = new fact("toolSuited", Array(new atom($i), new atom("average")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["summaryHandler.php"][] = $fact;		
			}	
			if($_SESSION["ToolSuited"] == 3){
				$fact = new fact("toolSuited", Array(new atom($i), new atom("poor")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["summaryHandler.php"][] = $fact;		
			}	
		}	
		$stringIdentifier = "toolNovel" . $i;
		if(isset($_POST[$stringIdentifier])){
			$_SESSION["ToolNovel"][$i] = $_POST[$stringIdentifier];
			if($_SESSION["ToolNovel"] == 1){
				$fact = new fact("toolNovel", Array(new atom($i)));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["summaryHandler.php"][] = $fact;
				
			}	
		}
		
	}
}

function clearSessionVariables(){
	if(isset($_SESSION["facts"]["summaryHandler.php"])){
		foreach($_SESSION["facts"]["summaryHandler.php"] as $fact){
			$_SESSION["kb"]->retract_fact($fact);
		}
	}
	unset($_SESSION["facts"]["summaryHandler.php"]);
	unset($_SESSION["error"]);
	unset($_SESSION["Techniques"]);
	unset($_SESSION["TechniqueQuantity"]);
	unset($_SESSION["TechniqueNames"]);
	unset($_SESSION["Problem"]);
	unset($_SESSION["NewProblemDescription"]);
	unset($_SESSION["ProblemSignificant"]);
	unset($_SESSION["ProblemSignificant"]);
	unset($_SESSION["ProblemSignificant"]);
	unset($_SESSION["ProblemSignificant"]);
	unset($_SESSION["Survey"]);
	unset($_SESSION["SurveyDescription"]);
	unset($_SESSION["SurveyDepth"]);
	unset($_SESSION["SurveyBreadth"]);
	unset($_SESSION["SurveyCurrent"]);
	unset($_SESSION["SurveyOmmisions"]);
	unset($_SESSION["SurveyOmitDescription"]);
	unset($_SESSION["HypothesisQuantity"]);
	unset($_SESSION["HypothesisNames"]);
	unset($_SESSION["HypothesisDescriptions"]);
	unset($_SESSION["HypothesisEvidenceDescriptions"]);
	unset($_SESSION["HypothesisEvidenceTypes"]);
	unset($_SESSION["HypothesisFormations"]);
	unset($_SESSION["System"]);
	unset($_SESSION["SystemName"]);
	unset($_SESSION["SystemType"]);
	unset($_SESSION["SystemDescription"]);
	unset($_SESSION["SystemAdvantages"]);
	unset($_SESSION["PreviousSystemDifferences"]);
	unset($_SESSION["PreviousSystemAuthor"]);
	unset($_SESSION["PreviousSystemName"]);
	unset($_SESSION["SystemDiffers"]);
	unset($_SESSION["ToolsQuantity"]);
	unset($_SESSION["ToolNames"]);
	unset($_SESSION["ToolDescriptions"]);
	unset($_SESSION["ToolSuited"]);
	unset($_SESSION["ToolNovel"]);
	unset($_SESSION["Techniques"]);
	unset($_SESSION["TechniqueQuantity"]);
	unset($_SESSION["TechniqueNames"]);
	unset($_SESSION["Problem"]);
	unset($_SESSION["NewProblemDescription"]);
	unset($_SESSION["ProblemSignificant"]);
	unset($_SESSION["ProblemSignificant"]);
	unset($_SESSION["ProblemSignificant"]);
	unset($_SESSION["Survey"]);
	unset($_SESSION["SurveyDescription"]);
	unset($_SESSION["SurveyDepth"]);
	unset($_SESSION["SurveyBreadth"]);
	unset($_SESSION["SurveyCurrent"]);
	unset($_SESSION["SurveyOmmisions"]);
	unset($_SESSION["SurveyOmitDescription"]);
	unset($_SESSION["HypothesisQuantity"]);
	unset($_SESSION["HypothesisNames"]);
	unset($_SESSION["HypothesisDescriptions"]);
	unset($_SESSION["HypothesisEvidenceDescriptions"]);
	unset($_SESSION["HypothesisEvidenceTypes"]);
	unset($_SESSION["HypothesisFormations"]);
	unset($_SESSION["System"]);
	unset($_SESSION["SystemName"]);
	unset($_SESSION["SystemType"]);
	unset($_SESSION["SystemDescription"]);
	unset($_SESSION["SystemAdvantages"]);
	unset($_SESSION["PreviousSystemDifferences"]);
	unset($_SESSION["PreviousSystemAuthor"]);
	unset($_SESSION["PreviousSystemName"]);
	unset($_SESSION["SystemDiffers"]);
	unset($_SESSION["ToolsQuantity"]);
	unset($_SESSION["ToolNames"]);
	unset($_SESSION["ToolDescriptions"]);
	unset($_SESSION["ToolSuited"]);
	unset($_SESSION["ToolNovel"]);
}

?>